;****************************************************************************************
;*                              180-SERVO-STELLER                                      *
;*                              26.01.20                                                *
;*                                                                                      *
;****************************************************************************************

        LIST    P=12F629       
        TITLE   "SERVO"

        ERRORLEVEL -302
        INCLUDE <P12F629.INC>

__CONFIG _HS_OSC & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _CPD_OFF & _CP_OFF


;--------------------------------------------------------------------------
;MIT QUARZ 16,000MHZ
;T=1 : F  T=1 : 16MHZ = 0,0625SEC
;MEIST T=4 DANN 0,25SEC        
;--------------------------------------------------------------------------
        
;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

;FUER ZEITSCHLEIFEN 
HELP0   EQU 0X22       
   
;FR INTERRUPT
W_STACK EQU 0X23
S_STACK EQU 0X24
 
;FUER RX-IMPULS GEMESSEN     
IMPULS    EQU 0X25
UEBERLAUF EQU 0X26 

;FUER 10SEC STELLEN + 5SEC IMPULS MESSEN/LESEN
MMERK    EQU 0X27
    
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;------------------------------- ENDE -------------------------------------
           
;ZAHLEN VON D'1' BIS D'255' KANN MANN EINTRAGEN !!!
;D'0' GEHT NICHT !!!   
         
;MINIMALE ZEIT IN SEC BZW. MSEC 
;WURDE GEMESSEN MIT SERVO-MESSEINRICHTUNG
;ALSO DIE KLEINSTE ZEIT WO DER SERVO "FAST" AM ANSCHLAG IST !!!
;BEISPIEL:
;FR 550SEC / 0,550MSEC WIRD 55 EINGETRAGEN
;FR 670SEC / 0,670MSEC WIRD 67 EINGETRAGEN
;FR 820SEC / 0,820MSEC WIRD 82 EINGETRAGEN
SERVO_TX_MIN            EQU D'66'
            
;MAXIMALE ZEIT IN SEC BZW. MSEC 
;WURDE GEMESSEN MIT SERVO-MESSEINRICHTUNG
;ALSO DIE GROESSTE ZEIT WO DER SERVO "FAST" AM ANSCHLAG IST !!!
;BERECHNUNG HIERZU :
;GEMESSEN ALS MAX-WERT = 1490SEC / 1,490MSEC  ENTSPRICHT "149" (SIEHE OBEN) 
;"149" -  "66"VON OBEN = "83" : 2 = "41" (GERUNDET) 
;ALS ERGEBNIS DIE "41" UNTEN EINTRAGEN MIT D'41'            
;SERVO_TX_MAX            EQU D'41'
            
;ANDERE BERECHNUNG :
;GEMESSEN ALS MAX-WERT = 2340SEC / 2,340MSEC  ENTSPRICHT "234" (SIEHE OBEN) 
;"234" -  "66"VON OBEN = "168" : 2 = "84" (GERUNDET) 
;ALS ERGEBNIS DIE "84" UNTEN EINTRAGEN MIT D'84'            
SERVO_TX_MAX            EQU D'84'
            
;--------------------------------------------------------------------------            
;MINIMALE ZEIT IN SEC BZW. MSEC 
;WURDE GEMESSEN MIT EMPFNGER-MESSEINRICHTUNG
;ALSO DIE KLEINSTE ZEIT WELCHE BEIM SERVO-ANSCHLUSS RAUS KOMMT !!!
;BEISPIEL:
;FR 1550SEC / 1,550MSEC WIRD 155 EINGETRAGEN
;FR 1110SEC / 1,110MSEC WIRD 111 EINGETRAGEN
;FR 1820SEC / 1,820MSEC WIRD 182 EINGETRAGEN
RX_IMPULS_MIN           EQU D'110' 
       
;ZAHLEN VON D'1' BIS D'255' KANN MANN EINTRAGEN !!!
;D'0' GEHT NICHT !!!   
       
;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7



;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; ZUM INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              04.05.12                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
                        MOVLW   B'11111110'                 ;GP0 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;INIT TIMER0
                        MOVLW   B'10000111'   ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                              ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG

;INIT INTERRUPT AN GP2
                        BCF     OPTION_REG, INTEDG  ;FALLENDE FLANKE ZULASSEN 
                        BANK0


                        BCF     GPIO, GP0                   ;AUS


;INTERRUPT GP2 INIT / ZULASSEN
;NUR FUER GP2 KEIN CHANGE !
;FR EMPFNGER-SERVO-IMPULS VON 1,9MSEC-2,1MSEC MESSEN
 
                        BSF     INTCON, PEIE        ;PEREPHERIE INTERRUPT ZULASSEN
                        BSF     INTCON, INTE        ;INTERRUPT EXTERNAL VON GP2 ZULASSEN

                        BCF     INTCON, GPIE        ;INTERRUPT FR EXTERNEN PIN NICHT ZULASSEN 
                                                    ;MIT CHANGE VON GP2 AUF GPX-EINGANG!!!

                        BCF     INTCON, GPIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                        BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                          ;BSF     INTCON, GIE         ;ALLGEMEINES INTERRUPT ENABLE ---->ERST SPTER !!!!!!!!!!!!!!!!!

                
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------
 
;ZEITSCHLEIFE 50MSEC                
                MOVLW   D'50'       ;50*1MSEC=50MSEC
                CALL    ZS1MSEC

                BSF     INTCON, GIE         ;ALLGEMEINES INTERRUPT ENABLE 
            
NOCHMAL         BCF     MMERK, BIT0
                GOTO    NOCHMAL
               

;*****************************************************************************
;*                              INTERRUPT                                    *
;*****************************************************************************
INTERRUPT       
            PUSH
 
;1XNOP= 4TAKTE * 0,0625SEC = 0,25SEC * 40XNOPS = 10SEC
            
            MOVLW   RX_IMPULS_MIN
            MOVWF   HELP0
            
ST          NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            ;NOP    WEG WEGEN ZEIT VON DECFSZ + GOTO
            ;NOP
            ;NOP
            
            DECFSZ  HELP0, F
            GOTO    ST
            
            
;JETZT GEMESSENE WERTE 
;---------------------------------------------------            
;0.25MYS (BEI 1XNOPS) 
;10SEC : 0.25SEC = 40 MAL NOP
            
            CLRF  IMPULS            
            CLRF  UEBERLAUF
            
ZS          BTFSC GPIO, GP2      ;INTERRUPT GP2 EINGANG
            GOTO  SCHLUSS
            
            ;NOP    ;WEGEN BTFSC WEGGENOMMEN
            ;NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
             
            NOP
            NOP
            NOP
            NOP
            NOP
                       
            BTFSC GPIO, GP2      ;INTERRUPT GP2 EINGANG
            GOTO  SCHLU1
            
            ;NOP WEGEN OBEN
            ;NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            ;NOP    WEG WEGEN ZEIT VON INCFSZ + GOTO
            ;NOP
            ;NOP

            INCFSZ  IMPULS, F
            GOTO    ZS
            BSF     UEBERLAUF, BIT0  ;BERLAUF-BIT GESETZT
            GOTO    SCHLUSS
;---------------------------------------------------            

SCHLU1      BSF     MMERK, BIT0
            
SCHLUSS
            CALL    STELLEN

                
                BCF     INTCON, GPIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                POP
                RETFIE
    
                          
            
;*****************************************************************************
;*                              SERVO STELLEN                                *
;*****************************************************************************
STELLEN
            BSF     GPIO, GP0        ;IMPULS GEHT LOS AUF HIGH
 
;1XNOP= 4TAKTE * 0,0625SEC = 0,25SEC * 40XNOPS = 10SEC
;HIER WIRD DIE MINIMALE ZEIT AUSGEGEBEN ANS SERVO
            
            MOVLW   SERVO_TX_MIN
            MOVWF   HELP0
            
ST_S        NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            ;NOP    WEG WEGEN ZEIT VON DECFSZ + GOTO
            ;NOP
            ;NOP
            
            DECFSZ  HELP0, F
            GOTO    ST_S
            
            
;---------------------------------------------------            
;0.25MYS (BEI 1XNOPS) 
;10SEC : 0.25SEC = 40 MAL NOP            
;JETZT ABER IN 20SEC : 0.25SEC = 80 MAL NOP  / DOPPELTE ZEIT / ALSO HUB

            MOVF    IMPULS, W
            MOVWF   HELP0
            SUBLW   0X00
            BTFSS   STATUS, Z
            GOTO    ZS_U
            MOVLW   0X01            
            MOVWF   HELP0
            GOTO    ZS_S
            
ZS_U        BTFSS   UEBERLAUF, BIT0
            GOTO    ZS_S1
            MOVLW   SERVO_TX_MAX ;0XFF            
            MOVWF   HELP0
            GOTO    ZS_S
            
ZS_S1       MOVLW   SERVO_TX_MAX
            SUBWF   HELP0, W
            BTFSS   STATUS, C
            GOTO    ZS_S
            MOVLW   SERVO_TX_MAX
            MOVWF   HELP0
     
ZS_S
            BTFSS   MMERK, BIT0
            GOTO    ZS_S2
 
            ;NOP
            ;NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP ;25X MAL
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP ;40X MAL

            
            
ZS_S2       NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP    
            NOP
            NOP
            
;40MAL NOPS BIS HIER            
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            NOP
            NOP
            NOP
            
            NOP
            NOP
            ;NOP    WEG WEGEN ZEIT VON DECFSZ + GOTO
            ;NOP
            ;NOP

            DECFSZ  HELP0, F
            GOTO    ZS_S2
 
;---------------------------------------------------            
           
            BCF     GPIO, GP0        ;IMPULS SCHLUSS AUF LOW

            RETURN                         
           
;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  1MSEC             *
;*                                                                           *
;*****************************************************************************
ZS1MSEC                 MOVWF   HELP0                   ;DER INHALT VON W WIRD IN "HELP1" GELADEN

T01                     MOVLW   D'240'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T02                     BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 10MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    T02                     ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"
                        
                        DECFSZ  HELP0, F                ;ES WIRD DER WERT IN "HELP1" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T01                     ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS
                        RETURN

;ZEITBERECHNUNG FUER 1MS
;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.0625SEC=64SEC       /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;1MS : 64SEC= 16                                                           /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;64S*D'16'=1,024MSEC
;TMR0 ALSO D'256'-D'16'=D'240' ENTSPRICHT CA. 10MSEC
;240 DEZIMAL OBEN EINTRAGEN
                        
                        
                        END
                    